<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_Seat ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_Seat extends AbstractStructArrayBase
{
    /**
     * The Seat
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_Seat[]
     */
    public $Seat;
    /**
     * Constructor method for ArrayOfJP_Seat
     * @uses ArrayOfJP_Seat::setSeat()
     * @param \StructType\JP_Seat[] $seat
     */
    public function __construct(array $seat = array())
    {
        $this
            ->setSeat($seat);
    }
    /**
     * Get Seat value
     * @return \StructType\JP_Seat[]|null
     */
    public function getSeat()
    {
        return $this->Seat;
    }
    /**
     * This method is responsible for validating the values passed to the setSeat method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSeat method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSeatForArrayConstraintsFromSetSeat(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_SeatSeatItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_SeatSeatItem instanceof \StructType\JP_Seat) {
                $invalidValues[] = is_object($arrayOfJP_SeatSeatItem) ? get_class($arrayOfJP_SeatSeatItem) : sprintf('%s(%s)', gettype($arrayOfJP_SeatSeatItem), var_export($arrayOfJP_SeatSeatItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Seat property can only contain items of type \StructType\JP_Seat, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Seat value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_Seat[] $seat
     * @return \ArrayType\ArrayOfJP_Seat
     */
    public function setSeat(array $seat = array())
    {
        // validation for constraint: array
        if ('' !== ($seatArrayErrorMessage = self::validateSeatForArrayConstraintsFromSetSeat($seat))) {
            throw new \InvalidArgumentException($seatArrayErrorMessage, __LINE__);
        }
        $this->Seat = $seat;
        return $this;
    }
    /**
     * Add item to Seat value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_Seat $item
     * @return \ArrayType\ArrayOfJP_Seat
     */
    public function addToSeat(\StructType\JP_Seat $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_Seat) {
            throw new \InvalidArgumentException(sprintf('The Seat property can only contain items of type \StructType\JP_Seat, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Seat[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_Seat|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_Seat|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_Seat|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_Seat|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_Seat|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Seat
     */
    public function getAttributeName()
    {
        return 'Seat';
    }
}
